/**
 * 
 * Copyright (c) Microsoft and contributors.  All rights reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * 
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 */

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

package com.microsoft.azure.management.compute.models;

/**
* Describes Windows Configuration of the OS Profile.
*/
public class LinuxConfiguration {
    private Boolean disablePasswordAuthentication;
    
    /**
    * Optional. Gets or sets whether Authentication using user name and
    * password is allowed or not
    * @return The DisablePasswordAuthentication value.
    */
    public Boolean isDisablePasswordAuthentication() {
        return this.disablePasswordAuthentication;
    }
    
    /**
    * Optional. Gets or sets whether Authentication using user name and
    * password is allowed or not
    * @param disablePasswordAuthenticationValue The
    * DisablePasswordAuthentication value.
    */
    public void setDisablePasswordAuthentication(final Boolean disablePasswordAuthenticationValue) {
        this.disablePasswordAuthentication = disablePasswordAuthenticationValue;
    }
    
    private SshConfiguration sshConfiguration;
    
    /**
    * Optional. Gets or sets the SSH configuration for linux VMs
    * @return The SshConfiguration value.
    */
    public SshConfiguration getSshConfiguration() {
        return this.sshConfiguration;
    }
    
    /**
    * Optional. Gets or sets the SSH configuration for linux VMs
    * @param sshConfigurationValue The SshConfiguration value.
    */
    public void setSshConfiguration(final SshConfiguration sshConfigurationValue) {
        this.sshConfiguration = sshConfigurationValue;
    }
}
