/**
 * 
 * Copyright (c) Microsoft and contributors.  All rights reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * 
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 */

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

package com.microsoft.azure.management.compute.models;

import com.microsoft.windowsazure.core.LazyArrayList;

import java.util.ArrayList;

/**
* Describes Windows Remote Management configuration of the VM
*/
public class WinRMConfiguration {
    private ArrayList<WinRMListener> listeners;
    
    /**
    * Optional. Gets or sets the list of Windows Remote Management listeners
    * @return The Listeners value.
    */
    public ArrayList<WinRMListener> getListeners() {
        return this.listeners;
    }
    
    /**
    * Optional. Gets or sets the list of Windows Remote Management listeners
    * @param listenersValue The Listeners value.
    */
    public void setListeners(final ArrayList<WinRMListener> listenersValue) {
        this.listeners = listenersValue;
    }
    
    /**
    * Initializes a new instance of the WinRMConfiguration class.
    *
    */
    public WinRMConfiguration() {
        this.setListeners(new LazyArrayList<WinRMListener>());
    }
}
