/**
 * 
 * Copyright (c) Microsoft and contributors.  All rights reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * 
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 */

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

package com.microsoft.azure.management.network.models;

/**
* A common class for general resource information
*/
public class ChildResource extends ResourceId {
    private String etag;
    
    /**
    * Optional. A unique read-only string that changes whenever the resource is
    * updated
    * @return The Etag value.
    */
    public String getEtag() {
        return this.etag;
    }
    
    /**
    * Optional. A unique read-only string that changes whenever the resource is
    * updated
    * @param etagValue The Etag value.
    */
    public void setEtag(final String etagValue) {
        this.etag = etagValue;
    }
    
    private String name;
    
    /**
    * Optional. Gets name of the resource that is unique within a resource
    * group. This name can be used to access the resource
    * @return The Name value.
    */
    public String getName() {
        return this.name;
    }
    
    /**
    * Optional. Gets name of the resource that is unique within a resource
    * group. This name can be used to access the resource
    * @param nameValue The Name value.
    */
    public void setName(final String nameValue) {
        this.name = nameValue;
    }
}
