/**
 * 
 * Copyright (c) Microsoft and contributors.  All rights reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * 
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 */

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

package com.microsoft.azure.management.sql.models;

import com.microsoft.windowsazure.core.LazyArrayList;
import com.microsoft.windowsazure.core.OperationResponse;

import java.util.ArrayList;

/**
* Represents Azure SQL Database Elastic Pool metrics.
*/
public class ElasticPoolMetrics extends OperationResponse {
    private ArrayList<Metric> metrics;
    
    /**
    * Optional. Gets or sets the list of Azure Sql Elastic Pool metrics.
    * @return The Metrics value.
    */
    public ArrayList<Metric> getMetrics() {
        return this.metrics;
    }
    
    /**
    * Optional. Gets or sets the list of Azure Sql Elastic Pool metrics.
    * @param metricsValue The Metrics value.
    */
    public void setMetrics(final ArrayList<Metric> metricsValue) {
        this.metrics = metricsValue;
    }
    
    /**
    * Initializes a new instance of the ElasticPoolMetrics class.
    *
    */
    public ElasticPoolMetrics() {
        super();
        this.setMetrics(new LazyArrayList<Metric>());
    }
}
