/**
 * 
 * Copyright (c) Microsoft and contributors.  All rights reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * 
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 */

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

package com.microsoft.azure.management.sql.models;

/**
* Create or update Azure Server Active Directory Administrator parameters
* properties.
*/
public class ServerAdministratorCreateOrUpdateProperties {
    private String administratorType;
    
    /**
    * Required. Gets the Azure SQL Server Active Directory Administrator Type.
    * @return The AdministratorType value.
    */
    public String getAdministratorType() {
        return this.administratorType;
    }
    
    /**
    * Required. Gets the Azure SQL Server Active Directory Administrator Type.
    * @param administratorTypeValue The AdministratorType value.
    */
    public void setAdministratorType(final String administratorTypeValue) {
        this.administratorType = administratorTypeValue;
    }
    
    private String login;
    
    /**
    * Required. Gets the Azure SQL Server Active Directory Administrator Login
    * Value.
    * @return The Login value.
    */
    public String getLogin() {
        return this.login;
    }
    
    /**
    * Required. Gets the Azure SQL Server Active Directory Administrator Login
    * Value.
    * @param loginValue The Login value.
    */
    public void setLogin(final String loginValue) {
        this.login = loginValue;
    }
    
    private String sid;
    
    /**
    * Required. Gets the Azure SQL Server Active Directory Administrator Sid.
    * @return The Sid value.
    */
    public String getSid() {
        return this.sid;
    }
    
    /**
    * Required. Gets the Azure SQL Server Active Directory Administrator Sid.
    * @param sidValue The Sid value.
    */
    public void setSid(final String sidValue) {
        this.sid = sidValue;
    }
    
    private String tenantId;
    
    /**
    * Required. Gets the Azure SQL Server Active Directory Administrator tenant
    * id.
    * @return The TenantId value.
    */
    public String getTenantId() {
        return this.tenantId;
    }
    
    /**
    * Required. Gets the Azure SQL Server Active Directory Administrator tenant
    * id.
    * @param tenantIdValue The TenantId value.
    */
    public void setTenantId(final String tenantIdValue) {
        this.tenantId = tenantIdValue;
    }
}
