/**
 * 
 * Copyright (c) Microsoft and contributors.  All rights reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * 
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 */

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

package com.microsoft.windowsazure.management.network.models;

import java.util.Calendar;

/**
* A management event for the virtual network gateway.
*/
public class GatewayEvent {
    private String data;
    
    /**
    * Optional. Additional data associated with this event.
    * @return The Data value.
    */
    public String getData() {
        return this.data;
    }
    
    /**
    * Optional. Additional data associated with this event.
    * @param dataValue The Data value.
    */
    public void setData(final String dataValue) {
        this.data = dataValue;
    }
    
    private String id;
    
    /**
    * Optional. The event ID.
    * @return The Id value.
    */
    public String getId() {
        return this.id;
    }
    
    /**
    * Optional. The event ID.
    * @param idValue The Id value.
    */
    public void setId(final String idValue) {
        this.id = idValue;
    }
    
    private String message;
    
    /**
    * Optional. The event message.
    * @return The Message value.
    */
    public String getMessage() {
        return this.message;
    }
    
    /**
    * Optional. The event message.
    * @param messageValue The Message value.
    */
    public void setMessage(final String messageValue) {
        this.message = messageValue;
    }
    
    private Calendar timestamp;
    
    /**
    * Optional. The date and time when the event occurred.
    * @return The Timestamp value.
    */
    public Calendar getTimestamp() {
        return this.timestamp;
    }
    
    /**
    * Optional. The date and time when the event occurred.
    * @param timestampValue The Timestamp value.
    */
    public void setTimestamp(final Calendar timestampValue) {
        this.timestamp = timestampValue;
    }
}
