/**
 * 
 * Copyright (c) Microsoft and contributors.  All rights reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * 
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 */

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

package com.microsoft.windowsazure.management.network.models;

/**
* Parameters supplied to the Create Virtual Network Gateway operation.
*/
public class VirtualNetworkGatewayCreateParameters {
    private String gatewayName;
    
    /**
    * Optional. The name of the virtual network gateway.
    * @return The GatewayName value.
    */
    public String getGatewayName() {
        return this.gatewayName;
    }
    
    /**
    * Optional. The name of the virtual network gateway.
    * @param gatewayNameValue The GatewayName value.
    */
    public void setGatewayName(final String gatewayNameValue) {
        this.gatewayName = gatewayNameValue;
    }
    
    private String gatewaySKU;
    
    /**
    * Optional. The SKU of this virtual network gateway. Valid values are
    * Default, HighPerformance and Standard.
    * @return The GatewaySKU value.
    */
    public String getGatewaySKU() {
        return this.gatewaySKU;
    }
    
    /**
    * Optional. The SKU of this virtual network gateway. Valid values are
    * Default, HighPerformance and Standard.
    * @param gatewaySKUValue The GatewaySKU value.
    */
    public void setGatewaySKU(final String gatewaySKUValue) {
        this.gatewaySKU = gatewaySKUValue;
    }
    
    private String gatewayType;
    
    /**
    * Optional. The routing type for this virtual network gateway.
    * @return The GatewayType value.
    */
    public String getGatewayType() {
        return this.gatewayType;
    }
    
    /**
    * Optional. The routing type for this virtual network gateway.
    * @param gatewayTypeValue The GatewayType value.
    */
    public void setGatewayType(final String gatewayTypeValue) {
        this.gatewayType = gatewayTypeValue;
    }
    
    private String location;
    
    /**
    * Optional. The location of the virtual network gateway.
    * @return The Location value.
    */
    public String getLocation() {
        return this.location;
    }
    
    /**
    * Optional. The location of the virtual network gateway.
    * @param locationValue The Location value.
    */
    public void setLocation(final String locationValue) {
        this.location = locationValue;
    }
    
    private String vnetId;
    
    /**
    * Optional. Virtual network Id.
    * @return The VnetId value.
    */
    public String getVnetId() {
        return this.vnetId;
    }
    
    /**
    * Optional. Virtual network Id.
    * @param vnetIdValue The VnetId value.
    */
    public void setVnetId(final String vnetIdValue) {
        this.vnetId = vnetIdValue;
    }
}
